// clcout.cpp : Defines the entry point for the console application.
//

//#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#ifndef M_PI
 #define M_PI (3.14159265358979323846264338328)
#endif


char pic[6912];
FILE * picfile;

FILE * outfile;


struct vec
{
	double x;
	double y;
};

struct attr
{
	int ax;
	int ay;
};

void do_render(double init_angle, int steps);

struct vec mkplane(double angle, double mul);

int chkplanes(double x, double y, struct vec b1, struct vec b2);

void scanout(double angle, struct vec b1, struct vec b2);

void fillattr(struct attr * as, double angle);

void filterwin(struct attr * as);

void filterplane(struct attr * as, struct vec b1, struct vec b2);


int main(void)
{
	picfile=fopen("interfac","rb");
	if( !picfile )
	{
		printf("cant open picfile!\n");
		exit(1);
	}

	if( 6912 != fread(pic, 1, 6912, picfile) )
	{
		printf("cant read picfile!\n");
		exit(1);
	}

	fclose(picfile);
	
	outfile=fopen("outfile","wb");
	if( !outfile )
	{
		printf("cant open outfile!\n");
		exit(1);
	}

	
	do_render(0.0, 9);

	fclose(outfile);

	return 0;
}

void do_render(double init_angle, int steps)
{
	double angle, angle_plus;
	int pos;

	char byte;
	
	struct vec b1, b2;
	
	
	for(pos=0;pos<steps;pos++)
	{
		angle      = init_angle + (((double)pos)/((double)steps))*M_PI*2.0;
		angle_plus = init_angle + (((double)(pos+1))/((double)steps))*M_PI*2.0;
printf("angle=%f, angle_plus=%f\n",angle,angle_plus);
		b1 = mkplane(angle,1.0);
		b2 = mkplane(angle_plus,(-1.0));
printf("b1.x=%f,b1.y=%f, b2.x=%f, b2.y=%f\n",b1.x,b1.y,b2.x,b2.y);
		
		scanout( ( ((double)(pos+pos+1)) / ((double)(steps+steps)) )*M_PI*2.0, b1, b2 );
	}

	byte = 0;
	if( 1!=fwrite(&byte,1,1,outfile) )
	{
		printf("cant write a byte!\n");
		exit(1);
	}	
}

struct vec mkplane(double angle, double mul)
{
	struct vec b;
	
	b.x = -sin(angle);
	b.y = cos(angle);
	
	b.x *= mul;
	b.y *= mul;
	
	return b;
}

int chkplanes(double x, double y, struct vec b1, struct vec b2)
{
	double r1, r2;
	
	r1 = x*b1.x + y*b1.y;
	r2 = x*b2.x + y*b2.y;
	
	return( (r1>=0.0) && (r2>0.0) );
}

void scanout(double angle, struct vec b1, struct vec b2)
{
	struct attr as[768];
	int i;
	int addr;
	char byte;

	fillattr(as, angle);
	filterwin(as);
	filterplane(as,b1,b2);
	
	for(i=0;i<768;i++)
	{
		if( as[i].ax>=0 && as[i].ay>=0 )
		{
			addr = as[i].ay*32 + as[i].ax + 0x1800;
			
			byte = pic[addr];
			if( 1!=fwrite(&byte,1,1,outfile) )
			{
				printf("cant write a byte!\n");
				exit(1);
			}
			
			byte = addr & 0x00FF;
			if( 1!=fwrite(&byte,1,1,outfile) )
			{
				printf("cant write a byte!\n");
				exit(1);
			}
			
			byte = ((addr>>8) & 0x00FF) + 0x0040;
			if( 1!=fwrite(&byte,1,1,outfile) )
			{
				printf("cant write a byte!\n");
				exit(1);
			}
		}
	}
	
	byte = 0;
	if( 1!=fwrite(&byte,1,1,outfile) )
	{
		printf("cant write a byte!\n");
		exit(1);
	}	
}

void fillattr(struct attr * as, double angle)
{
	int ax,ay;
	int i;
	
	
	// yet single fill type
	i=0;
	for(ay=0;ay<24;ay++)
	{
		for(ax=0;ax<32;ax++)
		{
			as[i].ax=ax;
			as[i].ay=ay;
			i++;
		}
	}
}

void filterwin(struct attr * as)
{
	int i;
	
	for(i=0;i<768;i++)
	{
		if( as[i].ax>=0 && as[i].ay>=0 )
		{
			if( as[i].ax>=4 && as[i].ax<28 && as[i].ay>=3 && as[i].ay<19 )
			{
				as[i].ax=(-1);
				as[i].ay=(-1);
			}
		}
	}
}

void filterplane(struct attr * as, struct vec b1, struct vec b2)
{
	int i;
	double x,y;
	
	for(i=0;i<768;i++)
	{
		if( as[i].ax>=0 && as[i].ay>=0 )
		{
			x = ((double)as[i].ax) - 15.5;
			y = ((double)as[i].ay) - 10.5;
		
			if( !chkplanes(x,y,b1,b2) )
			{
				as[i].ax = (-1);
				as[i].ay = (-1);
			}
		}
	}
}
