#include <stdio.h>
#include <stdlib.h>

#ifndef _WIN32
 #include <stdint.h>
#else
 typedef unsigned char uint8_t;
 typedef unsigned short int uint16_t;
 #define snprintf sprintf_s
 #pragma warning(disable : 4996)
#endif

#include <string.h>
#include <math.h>

#include "raycast.h"
#include "gencode.h"

extern struct raycast rc;



void gen_code(void)
{
	int i;
	int files_ok;

	FILE * txtable;
	
	FILE * acode;
	

//	FILE ** rmaps;
//	FILE ** lmaps;

	FILE ** amaps;
	
	
	FILE * rtexture;
	FILE * ltexture;

	char diffname[256];

	uint8_t * rtx;
	
/*
	rmaps=(FILE **)malloc( rc.scr_scroll_steps * sizeof(FILE *) );
	if( !rmaps )
	{
		printf("gen_code(): cant get mem for rmaps!\n");
		exit(1);
	}
*/
/*
	lmaps=(FILE **)malloc( rc.scr_scroll_steps * sizeof(FILE *) );
	if( !lmaps )
	{
		printf("gen_code(): cant get mem for lmaps!\n");
		exit(1);
	}
*/

	
	amaps=(FILE **)malloc( rc.scr_scroll_steps * sizeof(FILE *) );
	if( !amaps )
	{
		printf("gen_code(): cant get mem for amaps!\n");
		exit(1);
	}

	
	


	files_ok=1;

/*	
	for(i=0;i<rc.scr_scroll_steps;i++)
	{
		snprintf(diffname,sizeof(diffname),"rmap%d.bin",i);
printf("creating file %s\n",diffname);
		rmaps[i] = fopen(diffname,"wb");

		files_ok = files_ok && rmaps[i];
	}
*/
/*
	for(i=0;i<rc.scr_scroll_steps;i++)
	{
		snprintf(diffname,sizeof(diffname),"lmap%d.bin",i);
printf("creating file %s\n",diffname);
		lmaps[i] = fopen(diffname,"wb");

		files_ok = files_ok && lmaps[i];
	}
*/

	for(i=0;i<rc.scr_scroll_steps;i++)
	{
		snprintf(diffname,sizeof(diffname),"amap%d.bin",i);
printf("creating file %s\n",diffname);
		amaps[i] = fopen(diffname,"wb");

		files_ok = files_ok && amaps[i];
	}

	
	
	
	
	
	txtable = fopen("txtable.bin","wb");
	files_ok = files_ok && txtable;

	
	rtexture = fopen("rtexture.bin","wb");
	files_ok = files_ok && rtexture;


	ltexture = fopen("ltexture.bin","wb");
	files_ok = files_ok && ltexture;

	acode = fopen("acode.bin","wb");
	files_ok = files_ok && acode;
	

	if( !files_ok )
	{
		printf("gen_code(): cant create files!\n");
		exit(1);
	}
	

	mk_acode(acode, amaps);



	code_txtables(txtable);

	rtx = code_rtexture(rtexture);
	code_ltexture(ltexture,rtx);
	
	

/*	for(i=0;i<rc.scr_scroll_steps;i++)
	{
		code_rmaps(i,rmaps[i]);
	}
*/
/*
	for(i=0;i<rc.scr_scroll_steps;i++)
	{
		code_lmaps(i,lmaps[i]);
	}
*/
	




	fclose(acode);
	
	fclose(rtexture);
	fclose(ltexture);

	fclose(txtable);

	for(i=0;i<rc.scr_scroll_steps;i++)
	{
//		fclose(rmaps[i]);
//		fclose(lmaps[i]);
		fclose(amaps[i]);
	}

	
//	free(rmaps);
//	free(lmaps);
	free(amaps);


}




void mk_acode(FILE * acode, FILE ** amaps)
{
	int i;

	struct global_code_info gci;

	

	init_gci(&gci);

	
	analyze_txmaps(&gci);

	
	code_acode(&gci, acode);

	
	for(i=0;i<rc.scr_scroll_steps;i++)
	{
		code_amap(&gci, i, amaps[i]);
	}
}



void init_gci(struct global_code_info * gci)
{
	int i;

	gci->prologue = (-1);
	gci->epilogue = (-1);
	gci->ldscr_decY_ldX = (-1);
	gci->ldscr_addY_ldX = (-1);

	for(i=0;i<CODE_ARRAY_SIZE;i++)
	{
//		gci->fulls_notxinc[i] = (-1);
//		gci->fulls_txinc[i]   = (-1);
		gci->stlst_notxinc[i] = (-1);
		gci->stlst_txinc[i]   = (-1);
		
		gci->fulls[i] = NULL;
	}

	
//	gci->max_fulls_notxinc = 0;
//	gci->max_fulls_txinc   = 0;

	gci->max_stlst_notxinc = 0;
	gci->max_stlst_txinc   = 0;

	gci->max_fulls = 0;
	
	gci->no_byte_pops = 1;
}






void analyze_txmaps(struct global_code_info * gci)
{
	// get max_* values from xmap->left_tbi chains

	int i;

	struct txbyteinfo * prev;
	struct txbyteinfo * cur;
	
	int fulltx, fullno;
	int sttx,   stno;
	
	int count;
	int state = 0;
	

	fulltx = 1;
	fullno = 1;
	sttx = 0;
	stno = 0;

	
	// analyze fulls_* and stlst_*

	// loop through all lines
	for(i=(rc.scr_height_max-1);i>=(rc.scr_height_max-rc.scr_height);i--)
	{
		count = (-1);
		
	
		cur = rc.linemaps[i].xmap.left_tbi;
		prev = NULL;
		
		while( cur || prev )
		{
			if( !prev )
			{ // init
				count = 0;
				
				if( cur->byte_info==TBI_FULL )
				{
					state = TBI_FULL;
					
					count = 1;
				}
				else if( cur->byte_info==TBI_START )
				{
					state = TBI_START;
					
					count = 0;
				}
				else
				{
					printf("analyze_txmaps(): wrong starting byte_info!\n");
					exit(1);
				}
			}
			else // if( prev )
			{
				if( state == TBI_FULL )
				{
					if( !cur )
					{
						if( fullno < count )
							fullno = count;
					}
					else if( cur->byte_info == TBI_FULL )
					{
						if( cur->tx_x_byte == prev->tx_x_byte )
						{
							count++;
						}
						else // if( cur->tx_x_byte != prev->tx_x_byte )
						{
							if( fulltx < count )
								fulltx = count;
							
							count = 1;
						}
					}
					else if( cur->byte_info == TBI_START )
					{
						if( cur->tx_x_byte == prev->tx_x_byte )
						{
							if( fullno < count )
								fullno = count;
						}
						else // if( cur->tx_x_byte != prev->tx_x_byte )
						{
							if( fulltx < count )
								fulltx = count;
						}

						count = 0;
						state = TBI_START;
					}
					else
					{
						printf("analyze_txmaps(): wrong byte_info in TBI_FULL state!\n");
						exit(1);
					}
				}
				else if( state == TBI_START )
				{
					if( !cur )
					{
						if( stno < count )
							stno = count;
					}
					else if( cur->byte_info == TBI_START )
					{
						if( cur->tx_x_byte == prev->tx_x_byte )
						{
							if( stno < count )
								stno = count;
						}
						else // if( cur->tx_x_byte != prev->tx_x_byte )
						{
							if( sttx < count )
								sttx = count;
						}

						count = 0;
						state = TBI_START;
					}
					else if( cur->byte_info == TBI_MID )
					{
						count++;
					}
					else if( cur->byte_info == TBI_LAST )
					{
						// nothing
					}
					else if( cur->byte_info == TBI_FULL )
					{
						if( cur->tx_x_byte == prev->tx_x_byte )
						{
							if( stno < count )
								stno = count;
						}
						else // if( cur->tx_x_byte != prev->tx_x_byte )
						{
							if( sttx < count )
								sttx = count;
						}

						count = 1;
						state = TBI_FULL;
					}
					else
					{
						printf("analyze_txmaps(): wrong byte_info in TBI_START state!\n");
						exit(1);
					}
				}
				else
				{
					printf("analyze_txmaps(): wrong state encountered!\n");
					exit(1);
				}
			}
		
			prev = cur;
			if( cur )
				cur = cur->next;
		}
	}

printf("analyze_txmaps(): fullno=%d, fulltx=%d, stlstno=%d, stlsttx=%d\n",fullno,fulltx,stno,sttx);

//	gci->max_fulls_notxinc = fullno;
//	gci->max_fulls_txinc   = fulltx;

	gci->max_stlst_notxinc = stno;
	gci->max_stlst_txinc   = sttx;

	
	
	
	
	
	
	// analyze ALL fulls
	for(i=(rc.scr_height_max-1);i>=(rc.scr_height_max-rc.scr_height);i--)
	{
		cur = rc.linemaps[i].xmap.left_tbi;

		if( cur->byte_info == TBI_FULL )
		{
			state = 1;
			prev = cur;
		}
		else
		{
			state = 0;
			prev = NULL;
		}


		do
		{
			cur = cur->next;
			
			
			if( !cur )
			{
				if( state )
				{
					mk_fulls(gci, prev);
				}
			}
			else if( cur->byte_info == TBI_FULL )
			{
				if( !state )
				{
					prev = cur;
					state = 1;
				}
			}
			else // != TBI_FULL
			{
				if( state )
				{
					mk_fulls(gci, prev);
					state = 0;
				}
			}
			
			
		
		} while( cur );
	}

	
printf("analyze_txmaps(): fulls=%d\n",gci->max_fulls);

}





void mk_fulls(struct global_code_info * gci, struct txbyteinfo * start)
{
	struct full_info * cur;
	struct full_info * tmp;
	
	
	cur = build_fulls(start);

	tmp = find_fulls(gci, cur);
	
	if( !tmp )
	{
		add_fulls(gci, cur);
	}
}

struct full_info * find_fulls_tbi(struct global_code_info * gci, struct txbyteinfo * start)
{
	struct full_info * fi;
	
	fi = build_fulls(start);
	
	fi = find_fulls(gci, fi);
	
	if( !fi )
	{
		printf("find_fulls_tbi(): cant find given full_info in existing table!\n");
		exit(1);
	}
	
	return fi;
}



struct full_info * build_fulls(struct txbyteinfo * start)
{
	static struct full_info fi;
	static int txsteps[CODE_ARRAY_SIZE];
	
	int txstep;
	
	struct txbyteinfo * cur;

	
	
	if( !start )
	{
		printf("build_fulls(): start is NULL!\n");
		exit(1);
	}
	else if( start->byte_info != TBI_FULL )
	{
		printf("build_fulls(): start is not TBI_FULL!\n");
		exit(1);
	}

	

	cur = start;
	
	fi.size    = 0;
	fi.addr    = (-1);
	fi.txsteps = txsteps;

	while( cur && cur->byte_info==TBI_FULL )
	{
		if( !cur->next )
		{
			txstep = 0;
		}
		else
		{
			txstep = cur->next->tx_x_byte - cur->tx_x_byte;
		}
		
		fi.txsteps[fi.size++] = txstep;

		cur = cur->next;
	}

	return &fi;
}




void add_fulls(struct global_code_info * gci, struct full_info * fi)
{
	int * new_txsteps;
	struct full_info * new_fi;
	
	
	new_fi = (struct full_info *)malloc( sizeof(struct full_info) );
	if( !new_fi )
	{
		printf("add_fulls(): cant allocate mem for full_info!\n");
		exit(1);
	}
	
	new_txsteps = (int *)malloc( fi->size * sizeof(int) );
	if( !new_txsteps )
	{
		printf("add_fulls(): cant allocate mem for txsteps!\n");
		exit(1);
	}

	new_fi->addr = fi->addr;
	new_fi->size = fi->size;

	new_fi->txsteps = new_txsteps;
	
	memcpy(new_txsteps, fi->txsteps, fi->size * sizeof(int) );

	
	gci->fulls[gci->max_fulls++] = new_fi;
}

struct full_info * find_fulls(struct global_code_info * gci, struct full_info * fi)
{
	int i,j;
	int found;
	
	if( !gci->max_fulls )
	{
		return NULL;
	}
	
	
	for(i=0;i<gci->max_fulls;i++)
	{
		if( fi->size == gci->fulls[i]->size )
		{
			found = 1;
			for(j=0;j<fi->size;j++)
			{
				if( fi->txsteps[j] != gci->fulls[i]->txsteps[j] )
				{
					found = 0;
					break;
				}
			}
			
			if( found )
			{
				return gci->fulls[i];
			}
		}
	}
	
	return NULL;
}












void code_acode(struct global_code_info * gci, FILE * acode)
{
	int i,j;

	int code = CODE_START_ADDR;

	
	
	// mk epilogue
	gci->epilogue = code;
	//
	st_byte(acode, 0x31);
	st_word(acode, 0x3131); // LD SP,xxx
	//
	st_byte(acode, 0xC9); // RET
	//
	code += 4;

	
	// mk prologue
	// prologue regs: DE - old SP, A - tx y
	gci->prologue = code;
	//
	st_byte(acode, 0xED);
	st_byte(acode, 0x53);
	st_word(acode, (gci->epilogue+1)&0xFFFF); // LD (),DE
	//
	st_byte(acode, 0x6F); // LD L,A
	//
	st_byte(acode, 0xC9); // RET
	//
	code += 6;

	
	// mk load scr addr, tx X and add to tx Y
	gci->ldscr_addY_ldX = code;
	//
	st_byte(acode, 0xC1); // POP BC
	//
	st_byte(acode, 0x7D); // LD A,L
	//
	st_byte(acode, 0xE1); // POP HL   ;addY, ldX
	//
	st_byte(acode, 0x85); // ADD A,L
	//
	st_byte(acode, 0x6F); // LD L,A
	//
	st_byte(acode, 0xC9); // RET
	//
	code += 6;
	
	
	// mk load scr addr, tx X and dec tx Y
	gci->ldscr_decY_ldX = code;
	//
	st_byte(acode, 0xC1); // POP BC
	//
	if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
	//
	st_byte(acode, 0xF1); // POP AF    ;trash, ldX
	//
	st_byte(acode, 0x67); // LD H,A
	//
	st_byte(acode, 0x2D); // DEC L
	//
	st_byte(acode, 0xC9); // RET
	//
	code += 5 + (gci->no_byte_pops?0:1);

/*	
	// mk fulls with no tx inc at end
	for(i=1;i<=gci->max_fulls_notxinc;i++)
	{ // mk i fulls in row
	
		gci->fulls_notxinc[i] = code;
printf("full_notxinc[%d]=%x\n",i,code);
	
		for(j=0;j<i;j++)
		{
			st_byte(acode, 0xD1); // POP DE   ; tx tbl num, trash
			//
			if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
			//
			st_byte(acode, 0x56); // LD D,(HL)
			//
			st_byte(acode, 0x1A); // LD A,(DE)
			//
			st_byte(acode, 0x02); // LD (BC),A
			//
			st_byte(acode, 0x0C); // INC C
			//
			code += 5 + (gci->no_byte_pops?0:1);
		}
		
		st_byte(acode, 0xC9); // RET
		//
		code += 1;
	}

	
	// mk fulls with tx inc at end
	for(i=1;i<=gci->max_fulls_txinc;i++)
	{ // mk i fulls in row
	
		gci->fulls_txinc[i] = code;
printf("full_txinc[%d]=%x\n",i,code);
	
		for(j=0;j<i;j++)
		{
			st_byte(acode, 0xD1); // POP DE
			//
			if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
			//
			st_byte(acode, 0x56); // LD D,(HL)
			//
			st_byte(acode, 0x1A); // LD A,(DE)
			//
			st_byte(acode, 0x02); // LD (BC),A
			//
			st_byte(acode, 0x0C); // INC C
			//
			code += 5 + (gci->no_byte_pops?0:1);
		}
		
		st_byte(acode, 0x24); // INC H
		//
		st_byte(acode, 0xC9); // RET
		//
		code += 2;
	}
*/

	// mk stlst with no tx inc at end
	for(i=0;i<=gci->max_stlst_notxinc;i++)
	{
		gci->stlst_notxinc[i] = code;
printf("stlst_notxinc[%d]=%x\n",i,code);
		// START
		st_byte(acode, 0xD1); // POP DE
		//
		if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
		//
		st_byte(acode, 0x56); // LD D,(HL)
		//
		st_byte(acode, 0x24); // INC H
		//
		st_byte(acode, 0x1A); // LD A,(DE)
		//
		code += 4 + (gci->no_byte_pops?0:1);
		
		
		for(j=0;j<i;j++) // mk i mids
		{
			// MID
			st_byte(acode, 0xD1); // POP DE
			//
			if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
			//
			st_byte(acode, 0x56); // LD D,(HL)
			//
			st_byte(acode, 0x24); // INC H
			//
			st_byte(acode, 0xEB); // EXD
			//
			st_byte(acode, 0xB6); // OR (HL)
			//
			st_byte(acode, 0xEB); // EXD
			//
			code += 6 + (gci->no_byte_pops?0:1);
		}
		
		// LAST
		st_byte(acode, 0xD1); // POP DE
		//
		if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
		//
		st_byte(acode, 0x56); // LD D,(HL)
		//
		st_byte(acode, 0xEB); // EXD
		//
		st_byte(acode, 0xB6); // OR (HL)
		//
		st_byte(acode, 0xEB); // EXD
		//
		st_byte(acode, 0x02); // LD (BC),A
		//
		st_byte(acode, 0x0C); // INC C
		//
		st_byte(acode, 0xC9); // RET
		//
		code += 8 + (gci->no_byte_pops?0:1);
	}


	// mk stlst with tx inc at end
	for(i=0;i<=gci->max_stlst_txinc;i++)
	{
		gci->stlst_txinc[i] = code;
printf("stlst_txinc[%d]=%x\n",i,code);

		// START
		st_byte(acode, 0xD1); // POP DE
		//
		if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
		//
		st_byte(acode, 0x56); // LD D,(HL)
		//
		st_byte(acode, 0x24); // INC H
		//
		st_byte(acode, 0x1A); // LD A,(DE)
		//
		code += 4 + (gci->no_byte_pops?0:1);
		
		
		for(j=0;j<(i+1);j++)
		{
			// MID or LAST
			st_byte(acode, 0xD1); // POP DE
			//
			if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
			//
			st_byte(acode, 0x56); // LD D,(HL)
			//
			st_byte(acode, 0x24); // INC H
			//
			st_byte(acode, 0xEB); // EXD
			//
			st_byte(acode, 0xB6); // OR (HL)
			//
			st_byte(acode, 0xEB); // EXD
			//
			code += 6 + (gci->no_byte_pops?0:1);
		}
		
		st_byte(acode, 0x02); // LD (BC),A
		//
		st_byte(acode, 0x0C); // INC C
		//
		st_byte(acode, 0xC9); // RET
		//
		code += 3;
	}
	
	
	
	// mk fulls code
	for(i=0;i<gci->max_fulls;i++)
	{
		gci->fulls[i]->addr = code;
printf("fulls[%d]=%x\n",i,code);
		
		for(j=0;j<gci->fulls[i]->size;j++)
		{
			st_byte(acode, 0xD1); // POP DE
			//
			if( !gci->no_byte_pops ) st_byte(acode, 0x3B); // DEC SP
			//
			st_byte(acode, 0x56); // LD D,(HL)
			//
			st_byte(acode, 0x1A); // LD A,(DE)
			//
			st_byte(acode, 0x02); // LD (BC),A
			//
			st_byte(acode, 0x0C); // INC C
			//
			if( gci->fulls[i]->txsteps[j] == 1 )
			{
				st_byte(acode, 0x24); // INC H
			}
			else if( gci->fulls[i]->txsteps[j] != 0 )
			{
				printf("code_acode(): txstep is not 0 neither 1!\n");
				exit(1);
			}
			//
			code += 5 + (gci->no_byte_pops?0:1) + (gci->fulls[i]->txsteps[j]?1:0);
		}


		st_byte(acode, 0xC9); // RET
		//
		code += 1;
	}
	
	
}



void code_amap(struct global_code_info * gci, int diffnum, FILE * amap)
{
	int prev_tx_y, cur_tx_y;

	int scr_addr;
	int tx_x;

	int count, type, last_tx_x;
	
	struct diffmap * dm;

	struct txbyteinfo * tbi;
	struct txbyteinfo * beg_tbi;

	struct full_info * fi;




	// code prologue
	st_word(amap, gci->prologue);


	prev_tx_y = 0;
	
	dm = rc.diffmaps[diffnum];
	
	while(dm)
	{
		cur_tx_y = dm->y_tx_coord;
		
		scr_addr = ytoaddr(dm->y_scr_coord) + dm->line->xmap.left_scr_byte;
		
		tx_x = dm->line->xmap.left_tx_byte;
		
		tbi = dm->line->xmap.left_tbi;
		

		// code load scr addr, tx X and update tx Y
		if( cur_tx_y == (prev_tx_y-1) )
		{
			st_word(amap, gci->ldscr_decY_ldX);
			st_word(amap, scr_addr);
			if( gci->no_byte_pops )
			{
				st_byte(amap, tx_x+TXTR_HI_ADDR);
			}
			st_byte(amap, tx_x+TXTR_HI_ADDR);
		}
		else
		{
			st_word(amap, gci->ldscr_addY_ldX);
			st_word(amap, scr_addr);
			st_byte(amap, cur_tx_y-prev_tx_y);
			st_byte(amap, tx_x+TXTR_HI_ADDR);
		}

		
		last_tx_x = tx_x;
		beg_tbi = tbi;
		type = tbi->byte_info;
		//
		if( type == TBI_FULL )
		{
			count = 1;
		}
		else if( type == TBI_START )
		{
			count = 2;
		}
		else
		{
			printf("code_amap(): wrong starting tbi!\n");
			exit(1);
		}

		do
		{
			tbi = tbi->next;

			if( !tbi )
			{
				if( type==TBI_FULL )
				{
					fi = find_fulls_tbi(gci,beg_tbi);
					st_word(amap, fi->addr);
					code_tbi(amap,beg_tbi,count,gci->no_byte_pops);
				
					//st_word(amap, gci->fulls_notxinc[count]);
					//code_tbi(amap,beg_tbi,count,gci->no_byte_pops);
				}
				else if( type==TBI_START )
				{
					st_word(amap, gci->stlst_notxinc[count-2]);
					code_tbi(amap,beg_tbi,count,gci->no_byte_pops);
				}
				else
				{
					printf("code_amap(): wrong type at the end of tbi list!\n");
					exit(1);
				}
			}
			else if( type==TBI_FULL )
			{
				switch(tbi->byte_info)
				{
				case TBI_FULL:
					/*if( tbi->tx_x_byte != last_tx_x )
					{
						st_word(amap, gci->fulls_txinc[count]);
						code_tbi(amap,beg_tbi,count,gci->no_byte_pops);
						
						count = 1;
						beg_tbi = tbi;
					}
					else
					{*/
						count++;
					//}
				break;
			
				case TBI_START:
					/*if( tbi->tx_x_byte != last_tx_x )
					{
						st_word(amap, gci->fulls_txinc[count]);
					}
					else
					{
						st_word(amap, gci->fulls_notxinc[count]);
					}*/
					
					fi = find_fulls_tbi(gci,beg_tbi);
					st_word(amap, fi->addr);
					code_tbi(amap,beg_tbi,count,gci->no_byte_pops);
					
					count = 2;
					beg_tbi = tbi;
					type = TBI_START;
				break;
			
				case TBI_MID:
				case TBI_LAST:
				default:
					printf("code_amap(): wrong  tbi->byte_info in state==TBI_FULL!\n");
					exit(1);
				break;
				}
			}
			else if( type==TBI_START )
			{
				switch(tbi->byte_info)
				{
				case TBI_FULL:
					if( tbi->tx_x_byte != last_tx_x )
					{
						st_word(amap, gci->stlst_txinc[count-2]);
					}
					else
					{
						st_word(amap, gci->stlst_notxinc[count-2]);
					}

					code_tbi(amap,beg_tbi,count,gci->no_byte_pops);
					
					count = 1;
					beg_tbi = tbi;
					type = TBI_FULL;
				break;
			
				case TBI_START:
					if( tbi->tx_x_byte != last_tx_x )
					{
						st_word(amap, gci->stlst_txinc[count-2]);
					}
					else
					{
						st_word(amap, gci->stlst_notxinc[count-2]);
					}

					code_tbi(amap,beg_tbi,count,gci->no_byte_pops);
					
					count = 2;
					beg_tbi = tbi;
				break;
			
				case TBI_MID:
					count++;
				break;
			
				case TBI_LAST:
					//nothing
				break;
			
				default:
					printf("code_amap(): wrong  tbi->byte_info in state==TBI_START!\n");
					exit(1);
				break;
				}
			}
			else
			{
				printf("code_amap(): wrong type!\n");
				exit(1);
			}
			
			
			
			
			
			if( tbi )
				last_tx_x = tbi->tx_x_byte;
			
		} while(tbi);


		prev_tx_y = cur_tx_y;
		dm = dm->next;
	}

	

	// code epilogue
	st_word(amap, gci->epilogue);
}



void code_tbi(FILE * amap, struct txbyteinfo * tbi, int count, int no_byte_pops)
{
	int i;
	
	for(i=0;i<count;i++)
	{
		if( !tbi )
		{
			printf("code_tbi(): tbi list exhausted!\n");
			exit(1);
		}

		st_byte(amap, tbi->txtable->num);
		
		if( no_byte_pops )
		{
			st_byte(amap, tbi->txtable->num);
		}
	
		tbi = tbi->next;
	}


}



















void code_txtables(FILE * file)
{
	int i,j,k;

	int size;

	uint8_t * txtables;

	int max_bytesize;

	struct txbyte * tb;


	uint8_t map;



	if( rc.txbnum>255 )
	{
		printf("cant store more than 255 txtables!\n");
		exit(1);
	}

	size = (256L<<rc.txbyte_size);

	if( size>0x4000 )
	{
		printf("size of txtables is greater than 16k!\n");
		exit(1);
	}

	txtables = (uint8_t *)malloc( size * sizeof(uint8_t) );

	if( !txtables )
	{
		printf("cant get memory for txtables!\n");
		exit(1);
	}

	memset(txtables,0,size);




	max_bytesize = (1L<<rc.txbyte_size) - 1;

	

	tb = rc.txblist;

	for(i=(rc.txbnum-1);i>=0;i--)
	{
		if( !tb )
		{
			printf("txblist has lesser elements than txbnum!\n");
			exit(1);
		}

		for(j=0;j<=max_bytesize;j++)
		{
			map = 0;

			for(k=0;k<8;k++)
			{
				// index in bits[] is: 0 (MSB) to 7 (LSB) in resulting byte,
				// contents of bits[]: bits of texture byte 0 (MSB) to n (LSB)

				if( tb->bits[k] >= 0 )
					map |= (1&(j>>(rc.txbyte_size-1-tb->bits[k])))<<(7-k);
			}

			txtables[ j*256 + i ] = map;
		}

		tb = tb->next;
	}



	if( size != fwrite(txtables,1,size,file) )
	{
		printf("error writing txtables!\n");
		exit(1);
	}


	free(txtables);
}




uint8_t * code_rtexture(FILE * file)
{ // make example texture sized 256*rc.bit_width/rc.txbyte_size bytes

	int i,j;
	
	
	int sqsize;
	int sqsize_old;
	int sqoffs;
	
	int sq;
	
	int txbyte, txbit;
	

	int xbyte;

	uint8_t * img;
	
	size_t img_size;
	
	
	xbyte = rc.bit_width / rc.txbyte_size;
	
	img_size = 256*xbyte*sizeof(uint8_t);
	
	img = (uint8_t *)malloc( img_size );
	if( !img )
	{
		printf("code_texture(): cant get memory for image!\n");
		exit(1);
	}

	memset(img, 0, img_size);
	
	
	sqsize_old = (-1);
	for(i=0;i<256;i++) // Y texture coord
	{
		sqsize = 1L<<(i*NUM_TX_SQ/256);
		if( sqsize != sqsize_old )
		{
			sqsize_old = sqsize;
			sqoffs = 0;
		}
		else
			sqoffs++;


		for(j=0;j<rc.bit_width;j++) // X texture coord
		{
			// get color of given bit
			sq = 1 & ( (sqoffs/sqsize) + (j/sqsize) );
			
			// get texture byte and bit pos
			txbyte = i + 256*( j/rc.txbyte_size );
			txbit = 1<<( rc.txbyte_size - 1 - j%rc.txbyte_size );
			
			// set bit in texture
			if( sq )
				img[txbyte] |= txbit;	
		}
	}
	

	if( 1!=fwrite(img, img_size, 1, file) )
	{
		printf("code_rtexture(): cant write texture to file!\n");
		exit(1);
	}


	//free(img);
	return(img);
}


uint8_t * code_ltexture(FILE * file, uint8_t * rtx)
{ // input is texture generated by code_rtexture. output is our texture

	int i,j;

	uint8_t * img;
	
	size_t img_size;

		
	img_size = 256*rc.mem_tx_x_size*sizeof(uint8_t);
	
	img = (uint8_t *)malloc( img_size );
	if( !img )
	{
		printf("code_texture(): cant get memory for image!\n");
		exit(1);
	}

	memset(img, 0, img_size);


	
	
	for( i=0; i<256; i++ )
	{ // Y loop
	
		for( j=0; j<rc.mem_tx_x_size; j++ )
		{ // X loop
		
			img[j + i*rc.mem_tx_x_size] = rtx[i + j*256];
		}
	}
	
	
	if( 1!=fwrite(img, img_size, 1, file) )
	{
		printf("code_ltexture(): cant write texture to file!\n");
		exit(1);
	}
	

	
	
	return img;
}












void code_rmaps(int diffnum, FILE * file)
{
	int last_y_tx = 0, cur_y_tx;

	int last_num, last_tx;

	int b_notc;

	uint16_t scr_addr;

	struct diffmap * dm;

	struct txbyteinfo * tbi;

	int cur_tx, cur_num, type;



	st_byte(file,0xED);
	st_byte(file,0x73);
	st_word(file,SP_SAVE_ADDR); // LD (),SP


	dm = rc.diffmaps[diffnum];

	while(dm)
	{
		// regs: bc -- form here word to push
		//       hl -- txtables pointer
		//       de -- texture pointer

		scr_addr = ytoaddr(dm->y_scr_coord);

		cur_y_tx = dm->y_tx_coord;

		if( cur_y_tx == (last_y_tx+1) )
		{
			st_byte(file,0x1C); // INC E
		}
		else if( cur_y_tx == (last_y_tx-1) )
		{
			st_byte(file,0x1D); // DEC E
		}
		else
		{
			st_byte(file,0x3E);
			st_byte(file,(uint8_t)(cur_y_tx - last_y_tx)); // LD A,delta_tx_Y

			st_byte(file,0x83); // ADD A,E

			st_byte(file,0x5F); // LD E,A
		}
		
		last_y_tx = cur_y_tx;



		scr_addr += (uint16_t)(dm->line->xmap.right_scr_byte);

		st_byte(file,0x31); // LD SP,screen_address+1
		st_word(file,scr_addr+1);

		st_byte(file,0x16);
		st_byte(file,(uint8_t)(dm->line->xmap.right_tx_byte + TXTR_HI_ADDR)); // LD D,right_tx_ptr


		last_num = (-2);
		last_tx  = (-2);

		b_notc = 1;

		tbi = dm->line->xmap.right_tbi;

		while( tbi )
		{


			cur_tx  = tbi->tx_x_byte; // X tx coord
			cur_num = tbi->txtable->num; // txtable number

			type = tbi->byte_info;

			// load txtable number
			if( cur_num != last_num )
			{
				if( cur_num == (last_num+1) )
				{
					st_byte(file,0x2C); // INC L
				}
				else if( cur_num == (last_num-1) )
				{
					st_byte(file,0x2D); // DEC L
				}
				else
				{
					st_byte(file,0x2E);
					st_byte(file,(uint8_t)cur_num); // LD L,txtable num
				}
			}
			last_num = cur_num;



			// whether to load new texture byte
			if( cur_tx == last_tx )
			{ // no load texture
				switch( type )
				{
				case TBI_FULL:
					if( b_notc )
					{
						st_byte(file,0x46); // LD B,(HL)
					}
					else
					{
						st_byte(file,0x4E); // LD C,(HL)

						st_byte(file,0xC5); // PUSH BC
					}
					b_notc = !b_notc;
				break;

				case TBI_START:
					st_byte(file,0x7E); // LD A,(HL)
				break;

				case TBI_MID:
					st_byte(file,0xB6); // OR (HL)
				break;

				case TBI_LAST:
					st_byte(file,0xB6); // OR (HL)
					
					if( b_notc )
					{
						st_byte(file,0x47); // LD B,A
					}
					else
					{
						st_byte(file,0x4F); // LD C,A

						st_byte(file,0xC5); // PUSH BC
					}
					b_notc = !b_notc;
				break;
				}
			}
			else
			{ // load texture
				switch( type )
				{
				case TBI_FULL:
				case TBI_START:
					st_byte(file,0x1A); // LD A,(DE)

					st_byte(file,0x15); // DEC D

					st_byte(file,0x67); // LD H,A

					if( type == TBI_START )
					{
						st_byte(file,0x7E); // LD A,(HL)
					}
					else // type == TBI_FULL
					{
						if( b_notc )
						{
							st_byte(file,0x46); // LD B,(HL)
						}
						else
						{
							st_byte(file,0x4E); // LD C,(HL)
                                                
							st_byte(file,0xC5); // PUSH BC
						}
						b_notc = !b_notc;
					}
				break;

				case TBI_MID:
				case TBI_LAST:
					st_byte(file,0xEB); // EXD

					st_byte(file,0x56); // LD D,(HL)

					st_byte(file,0xEB); // EXD

					st_byte(file,0x15); // DEC D

					st_byte(file,0xB6); // OR (HL)

					if( type == TBI_LAST )
					{
						if( b_notc )
						{
							st_byte(file,0x47); // LD B,A
						}
						else
						{
							st_byte(file,0x4F); // LD C,A
                                                
							st_byte(file,0xC5); // PUSH BC
						}
						b_notc = !b_notc;
					}
				break;
				}

			}
			last_tx = cur_tx;




			tbi = tbi->next;
		}


		// finalize push, if needed
		if( !b_notc )
		{
			st_byte(file,0x0E);
			st_byte(file,0x00); // LD C,0

			st_byte(file,0xC5); // PUSH BC
		}



		dm = dm->next;
	}





	st_byte(file,0xED);
	st_byte(file,0x7B);
	st_word(file,SP_SAVE_ADDR); // LD SP,()

	st_byte(file,0xC9); // RET
}














void code_lmaps(int diffnum, FILE * file)
{
	int cur_y_tx;

	int last_num, last_tx;
	

	int b_notc;

	uint16_t last_scr_addr;
	uint16_t scr_addr;

	uint16_t tx_a;
	uint16_t last_tx_a;
	
	uint8_t x,y,u,w;

	struct diffmap * dm;

	struct txbyteinfo * tbi;

	int cur_tx, cur_num, type;

	
	
	


	st_byte(file,0xED);
	st_byte(file,0x73);
	st_word(file,SP_SAVE_ADDR); // LD (),SP
	
	st_byte(file,0xF9); // LD SP,HL


	dm = rc.diffmaps[diffnum];

	last_scr_addr = 0xFFFF;
	last_tx_a = 0;
	
	while(dm)
	{
		// regs: BC -- pop texture here
		//       HL -- txtables pointer
		//       DE -- screen pointer

		
		cur_y_tx = dm->y_tx_coord;

		// code for stepping and wrapping in texture (SP)
		tx_a = cur_y_tx * rc.mem_tx_x_size + dm->line->xmap.left_tx_byte;
		
		if( last_tx_a != tx_a )
		{
			st_byte(file,0x21);
			st_word(file,tx_a-last_tx_a); // LD HL,diff
		
			st_byte(file,0x39); // ADD HL,SP
		
			st_byte(file,0xCB);
			st_byte(file,0xE4); // SET 4,H

			if( last_tx_a < tx_a )
			{
				st_byte(file,0xCB);
				st_byte(file,0xAC); // RES 5,H
			}
		
			st_byte(file,0xF9); // LD SP,HL
		}
		





		scr_addr = ytoaddr(dm->y_scr_coord);
		scr_addr += dm->line->xmap.left_scr_byte;


		last_num = (-2);
		last_tx  = (-2);

		b_notc = 0;

		tbi = dm->line->xmap.left_tbi;

		while( tbi )
		{
			// code for loading new scr ptr (DE)
			x = (scr_addr>>8)&0xFF;
			y = (last_scr_addr>>8)&0xFF;
		
			u = scr_addr&0xFF;
			w = last_scr_addr&0xFF;

			if( ( ((x+1)&255)==y || ((x-1)&255)==y || x==y ) &&
			    ( ((u+1)&255)==w || ((u-1)&255)==w || u==w ) )
			{
				if( x!=y )
				{
					st_byte(file, (x>y)?0x14:0x15);// INC/DEC D
				}
				if( u!=w )
				{
					st_byte(file, (u>w)?0x1C:0x1D);// INC/DEC E
				}
			}
			else
			{
				if( x==y )
				{
					st_byte(file, 0x1E);
					st_byte(file, u);    // LD E,num
				}
				else if( u==w )
				{
					st_byte(file, 0x16);
					st_byte(file, x);    // LD D,num
				}
				else
				{
					st_byte(file, 0x11);
					st_byte(file, u);
					st_byte(file, x);   // LD DE,num
				}
			}

			last_scr_addr = scr_addr;





			cur_tx  = tbi->tx_x_byte; // X tx coord
			cur_num = tbi->txtable->num; // txtable number

			type = tbi->byte_info;

			// load txtable number
			if( cur_num != last_num )
			{
				if( cur_num == (last_num+1) )
				{
					st_byte(file,0x2C); // INC L
				}
				else if( cur_num == (last_num-1) )
				{
					st_byte(file,0x2D); // DEC L
				}
				else
				{
					st_byte(file,0x2E);
					st_byte(file,(uint8_t)cur_num); // LD L,txtable num
				}
			}
			last_num = cur_num;



			// whether to load new texture byte
			if( cur_tx != last_tx )
			{
				if( b_notc )
				{ // load from B
					st_byte(file,0x60); // LD H,B
				}
				else
				{ // load from C
				
					st_byte(file,0xC1); // POP BC
					tx_a += 2;
					
					st_byte(file,0x61); // LD H,C
				}
			
				b_notc = !b_notc;
			}

			// put textured byte to screen/to accumulator
			switch( type )
			{
			case TBI_FULL:
				
				st_byte(file, 0xED);
				st_byte(file, 0xA0); // LDI
				
				last_scr_addr++;
				scr_addr++;
				
				last_num++;
			break;
			
			case TBI_START:
			
				st_byte(file, 0x7E); // LD A,(HL)
			break;
			
			case TBI_MID:
			
				st_byte(file, 0xB6); // OR (HL)
			break;
			
			case TBI_LAST:
			
				st_byte(file, 0xB6); // OR (HL)
				
				st_byte(file, 0x12); // LD (DE),A
				
				//st_byte(file, 0x1C); // INC E
				//
				//scr_addr = (scr_addr&0xFF00) | ((scr_addr+1)&0x00FF);
				scr_addr++;
			break;
			}


			last_tx = cur_tx;

			tbi = tbi->next;
		}




		
		//last_scr_addr = scr_addr;
		last_tx_a = tx_a;

		dm = dm->next;
	}





	st_byte(file,0xED);
	st_byte(file,0x7B);
	st_word(file,SP_SAVE_ADDR); // LD SP,()

	st_byte(file,0xC9); // RET
}































void st_byte(FILE * file, uint8_t byte)
{
	if( 1 != fwrite(&byte,1,1,file) )
	{
		printf("st_byte(): cant write to file!\n");
		exit(1);
	}
}


void st_word(FILE * file, uint16_t word)
{
	uint8_t byte0, byte1;

	byte0 = word&255;
	byte1 = (word>>8)&255;

	st_byte(file,byte0);
	st_byte(file,byte1);
}



uint16_t ytoaddr(int y)
{ // y (0..191) to zx screen addr

	uint16_t addr;

	if( y<0 || y>=192 )
	{
		printf("ytoaddr(): y out of range!\n");
		exit(1);
	}


	addr = 0;

	addr |= (y&7)<<8; // 10..8

	addr |= ((y>>3)&7)<<5; // 7..5

	addr |= ((y>>6)&3)<<11; // 12..11

	addr |= 0x4000;


	return addr;
}


