#ifndef _GENCODE_H_
#define _GENCODE_H_

#define SP_SAVE_ADDR    (0xFFFE)
#define TXTR_HI_ADDR    (0x80)
#define CODE_START_ADDR (0xAE00)

#define NUM_TX_SQ (5)

#define CODE_ARRAY_SIZE 256




struct full_info
{
	int size;

	int addr;

	int * txsteps;
};


struct global_code_info
{
	int prologue; // SP save and load alone-table to it,
	              // load texture Y, start code

	int epilogue; // restore SP and return
	
	int ldscr_decY_ldX; // dec tx Y and load tx X, also load scr addr
	
	int ldscr_addY_ldX; // add to tx Y and load tx X, also load scr addr

//	int fulls_notxinc[CODE_ARRAY_SIZE];
//	int fulls_txinc[CODE_ARRAY_SIZE];
	
	int stlst_notxinc[CODE_ARRAY_SIZE];
	int stlst_txinc[CODE_ARRAY_SIZE];

	
//	int max_fulls_notxinc;
//	int max_fulls_txinc;
	
	int max_stlst_notxinc;
	int max_stlst_txinc;


	struct full_info * fulls[CODE_ARRAY_SIZE];
	int                max_fulls;
	
	
	
	int no_byte_pops;
};








void gen_code(void);

void code_txtables(FILE * file);

uint8_t * code_rtexture(FILE * file);
uint8_t * code_ltexture(FILE * file, uint8_t * img);


void code_rmaps(int diffnum, FILE * file);
void code_lmaps(int diffnum, FILE * file);



void init_gci(struct global_code_info * gci);

void mk_acode(FILE * acode, FILE ** amaps);

void code_tbi(FILE * amap, struct txbyteinfo * tbi, int count, int no_byte_pops);

void analyze_txmaps(struct global_code_info * gci);

void mk_fulls(struct global_code_info * gci, struct txbyteinfo * start);
struct full_info * build_fulls(struct txbyteinfo * start);
struct full_info * find_fulls(struct global_code_info * gci, struct full_info * fi);
struct full_info * find_fulls_tbi(struct global_code_info * gci, struct txbyteinfo * start);
void add_fulls(struct global_code_info * gci, struct full_info * fi);



void code_acode(struct global_code_info * gci, FILE * acode);

void code_amap(struct global_code_info * gci, int diffnum, FILE * amap);



void st_byte(FILE * file, uint8_t byte);
void st_word(FILE * file, uint16_t word);


uint16_t ytoaddr(int y);






#endif // _GENCODE_H_

