#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "raycast.h"
#include "genmap.h"

extern struct raycast rc;


void gen_maps(FILE * file)
{
	int i;

	struct diffmap * dm;

	struct txbyteinfo * tbi;



	if(!file) return;





	fprintf(file,"ISCRLINE\tEQU\t%d ;starting initial screen line\n",rc.scr_height_max-rc.scr_height);

	fprintf(file,"TX_BITWIDTH\tEQU\t%d ;width of texture in bits\n",rc.bit_width);
	fprintf(file,"TX_BYTESIZE\tEQU\t%d ;width of texture byte\n",rc.txbyte_size);
	fprintf(file,"TX_NUMBYTES\tEQU\t%d ;width of texture in bytes\n",rc.bit_width/rc.txbyte_size);

	fprintf(file,"NUM_MAPS\tEQU\t%d ;number of maps\n",rc.scr_scroll_steps);

	fprintf(file,"NUM_TABLES\tEQU\t%d ;number of tx tables\n",rc.txbnum);

	fprintf(file,"\nDIFFMAPS\t\t;table of diffmaps\n");
	for(i=0;i<rc.scr_scroll_steps;i++)
	{
		fprintf(file,"\tDW\tDIFFMAP%d\n",i);	
	}

	fprintf(file,"\tDW\t0\n\n");	



	// gen diffmaps
	for(i=(rc.scr_scroll_steps-1);i>=0;i--)
	{
		fprintf(file,"\nDIFFMAP%d\n",(rc.scr_scroll_steps-1-i));


		dm = rc.diffmaps[i];

		while( dm )
		{
			fprintf(file,"\tDB\t%d ;screen Y coord\n",dm->y_scr_coord);
			fprintf(file,"\tDB\t%d ;tx Y coord\n\n",dm->y_tx_coord);

			tbi = dm->line->xmap.right_tbi;

			while( tbi )
			{
				fprintf(file,"\tDB\t%d ;scr X byte\n",tbi->scr_x_byte);
				fprintf(file,"\tDB\t%d ;tx X byte\n",tbi->tx_x_byte);
				fprintf(file,"\tDB\t%d ;txtable number\n",tbi->txtable->num);
				fprintf(file,"\tDB\t%d ;txtable type\n",tbi->byte_info);

				tbi = tbi->next;
			}
			
			fprintf(file,"\tDB\t255 ;endflag for txtable\n\n");


			dm = dm->next;
		}

		fprintf(file,"\tDB\t255 ;endflag for diffmap\n\n");
	}



	// gen txtables
	fprintf(file,"\nTXTABLES ;bits are numbered hzkak\n\n");



	recursive_reverse_gen_txtables(file,rc.txblist);
	fprintf(file,"\tDB\t255,255,255,255,255,255,255,255 ;txtables endflag\n\n");
}




void recursive_reverse_gen_txtables(FILE * file, struct txbyte * tb)
{
	int i;

	if( tb->next )
	{
		recursive_reverse_gen_txtables(file,tb->next);
	}

	
	fprintf(file,"\tDB\t");

	for(i=0;i<8;i++)
	{
		fprintf(file,"%d",tb->bits[i]);
		if(i<7)
			fprintf(file,",");
	}
	
	fprintf(file,"\n");

}

